/****************************************************
**
** PICProgrammerHardware.H
**
****************************************************/

#ifndef PICPROGRAMMERHARDWARECLASS_H
#define PICPROGRAMMERHARDWARECLASS_H

class PICProgrammerHardwareClass {

public:
	PICProgrammerHardwareClass( void );
	virtual ~PICProgrammerHardwareClass( void );

	virtual int		Found( void ) 			= 0;
	virtual char *	Get_Description( void ) = 0;

	void 	Off( void );
	void 	Program( void );
	void	Send_Data_Bit( int bit );
	int		Get_Data_Bit( void );
	void	Debug( void );

protected:
	typedef	enum {
		VPP_ON		= 1,
		VPP_OFF		= 2,
		VDD_ON		= 4,
		VDD_OFF		= 8,
		CLOCK_ON	= 16,
		CLOCK_OFF	= 32,
		DATA_ON		= 64,
		DATA_OFF	= 128,
	} StateBits;

	typedef enum {
		NO_ERROR				= 0,
		PORT_NOT_FOUND_ERROR,
		PROGRAMMER_NOT_FOUND_ERROR,
		CLOCK_DELAY 			= 1,
		POWER_UP_DELAY			= 1,
		PROGRAMMING_START_DELAY	= 1,
	} ClassConstants;

	virtual void	Set_State( int state_bits )		= 0;
	virtual int		Get_Input( void )				= 0;
};

#endif // PICPROGRAMMERHARDWARECLASS_H
